"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadJsonFile = void 0;
const detect_indent_1 = __importDefault(require("detect-indent"));
const graceful_fs_1 = __importDefault(require("graceful-fs"));
const parse_json_1 = __importDefault(require("parse-json"));
const strip_bom_1 = __importDefault(require("strip-bom"));
const strip_json_comments_1 = __importDefault(require("strip-json-comments"));
const strip_json_trailing_commas_1 = __importDefault(require("strip-json-trailing-commas"));
/** returns additional info, not only JSON */
const loadJsonFile = async (filePath, { encoding, tabSize, removeJsonc: jsonc }) => {
    let contents = (0, strip_bom_1.default)(await graceful_fs_1.default.promises.readFile(filePath, encoding));
    if (jsonc) {
        contents = (0, strip_json_trailing_commas_1.default)((0, strip_json_comments_1.default)(contents, { whitespace: false }));
    }
    return {
        json: (0, parse_json_1.default)(contents, filePath),
        indent: tabSize === 'preserve' ? (0, detect_indent_1.default)(contents).indent : tabSize === 'hard' ? '\t' : tabSize === null ? undefined : ' '.repeat(tabSize),
    };
};
exports.loadJsonFile = loadJsonFile;
